______________________________________________________________________________

YTD v1.51                                                    (c) 2009-15 Pepak
http://www.pepak.net/ytd                                  http://www.pepak.net
______________________________________________________________________________

CHANGELOG
---------

  v1.51:

    * Updated the slovak translation, thanks to Vladimír Kubala.

    * New providers:
      - iConcerts.com
      - ItsAllGay.com
      - RandyBlue.com (porn)
      - Streamin.to

    * Updated providers:
      - CeskaTelevize.cz
      - DrsnySvet.cz
      - PornHub.com (porno)
      - RedTube.com (porno)
      - TVNoe.cz
      - YouTube.com



  v1.50:

    * New providers:
      - RVP.cz
      - Tumblr.com (porn)

    * Updated providers:
      - Aktualne.cz
      - XHamster.com
      - YouTube.com

    * The notification about missing OpenSSL was enhanced with the ability to
      download and install a verified OpenSSL version from my server. That
      should help the users who can't decide which version of OpenSSL to 
      install. The downloaded version will get unpacked into YTD's directory,
      so it won't influence any other programs on the computer.
      Note that you may need to run YTD with administrative privileges if
      you want to make use of this functionality (it depends on the access
      rights to the directory where YTD is installed).

    * In order to satisfy copyright requirements completely, I removed the
      RTMPDUMP (RTMP protocol support, GPLv2) and MSDL (RTSP protocol support,
      GPLv3) libraries.

      If YTD detects that these libraries are missing, it will offer you to
      download and install them separately, thus satisfying both GPLs. It
      works the same way the OpenSSL installation (above) does.

      You can also download the libraries manually:
      http://www.pepak.net/files/youtube/external/rtmpdump.zip
      http://www.pepak.net/files/youtube/external/msdl.zip
      
      Note: The original implementation was probably OK, but it was rather 
      stretching the grey zone of GPL. The current implementation satisfies
      GPL completely, YTD no longer contains any GPL code.

    * New configuration settings:

      - Minimize to tray:

        You can now decide whether you want YTD to minimize into a tray icon
        (default) or simply minimize to taskbar.

      - Automatically delete finished downloads:

        When you enable this option, after a download is completed, its record
        will be removed from the download list automatically. Of course this 
        only influences the download list, the downloaded video will remain.
        Beware, though, that it is not always possible to correctly determine
        whether a download completed successfully. In some cases YTD has to
        make a guess, and this guess could easily be wrong!

      - Add index to the playlist's items:

        By default playlist items are named as per their detected title. Using
        this option, you can supplement the title with the item's index -
        either by appending the index to the end of the title, giving you
        names such as "xxx [1 of 5]", or by placing the index before the
        title, giving you names such as "[1 of 5] xxx".

    * The scripting language now has a <if> command for conditional execution.



  v1.49:

    * Updated providers:
      - CeskaTelevize.cz

  
  
  v1.48:

    * New providers:
      - DansMovies.com (porn)
      - EroProfile.com (porn)

    * Updated providers:
      - CekniTo.sk, CekniTo.cz
      - CeskaTelevize.cz
      - DailyMail.co.uk
      - DrsnySvet.cz
      - MediaSport.cz
      - NavratDoReality.cz
      - RTVS.sk
      - Vimeo.com
      - YouTube.com
      - ZDF.de

    * Removed providers:
      - Prima.cz
      - SerialyCZ.cz
      - Stream.cz
      - Video.nur.kz

    * Updated the slovak translation (Vladimír Kubala).

    * YouTube.com: Re-done the quality calculation for videos, this solves
      incorrect stream choice for http://www.youtube.com/watch?v=qToW_UtdF7o.
      Changed filename processing, solves multiline names such as in
      https://www.youtube.com/watch?v=iMIM1fjbkb0.

    * CeskaTelevize.cz: Added support for javascript embedded players.

      I was checking out Déčko, but it seems to me it doesn't use videos;
      instead normal Flash animations are shown. If that is not the case,
      please let me know.

      Updated the naming of videos (e.g. the News).



  v1.47:

    * CeskaTelevize.cz: Support for multi-part videos.

    * YouTube.com: Discovered the reason why many people couldn't download
      from YouTube correctly. Turns out YouTube has been switching to 
      encrypted transfers over the SSL protocol. YTD supports SSL only if
      OpenSSL library is installed. Apparently many people do not have 
      OpenSSL, so they couldn't download the main page only rarely when
      YouTube decided not to request SSL. That's why it was generally
      possible to download the video after a number of attempts.
      YTD now checks for the presence of OpenSSL and offers that you download
      and install it. If you don't like that, you can download OpenSSL
      manually (http://slproweb.com/products/Win32OpenSSL.html) or disable
      the warning in the configuration.

    * The scripting language has been documented (see doc/scripting.en.txt).



  v1.46:

    * New providers:
      - SultanCesky.cz

    * Updated providers:
      - CeskaTelevize.cz
      - Facebook.com
      - PornHub.com
      - XNXX.com
      - XTube.com

    * CeskaTelevize.cz was completely rewritten. I didn't have the time to
      handle the subtitles, that may follow sometime in the future, but the
      video downloads work fine. Supported are partial videos (e.g. just
      a single part of Udalosti) and the quality selection (which URL you
      choose, that's the quality you get).

      Note that in some cases a video may not be downloadable directly from
      its page, but if you find the embedded IFRAME's URL, it will work OK.
      The IFRAME's URL should look like this:
      http://www.ceskatelevize.cz/ivysilani/embed/iFramePlayer.php?hash=f0a72181ab9628a6ee67fc5d5babbde8f720befb&IDEC=210%20522%2016142&width=598&flash&noShow=false
      I noticed this is often the case if a video's page only contains a
      preview and only after clicking you get to the full video.

    * YouTube.com download was switched to SSL. We shall see if it helps with
      "Failed to download media info page". Unfortunately, it works perfectly
      for me so I can't properly debug the cause.



  v1.45:

    * Fixed the incorrect .com extension with YouTube.com and probably others.

    * Joj.sk doesn't work at the moment: You will need to find the token, and
      I will need to figure out how to add the authentication support to YTD.
      Given how Joj.sk uses it, that is not easy at all.


  v1.44:

    * New providers:
      - BravoTube.net (porn)
      - SexTubeSpot.com (porn)

    * Updated providers:
      - CeskaTelevize.cz
      - Joj.sk
      - Rtvs.sk (also stv.sk)
      - TV7.cz
      - YouTube.com

    * New configuration option "Retry count" determines the number of attempts
      to redownload a failed download. More information can be found in the
      documentation (search for "download_retry_count").
      Warning: This is a highly experimental setting!

    * Several new function and settings for the YTD scripting language.



  v1.43:

    * New providers:
      - ABC.net.au
      - NovaPlus.Nova.cz
      - OptoMedia.cz (OptoBone.cz)

    * Updated providers:
      - JenProMuze.cz
      - RedTube.com
      - Natabanu.com
      - NavratDoReality.cz
      - Video.Tiscali.cz

    * TVcom.cz is currently out of service. It would be easy to download from
      it, but to make it is pointless unless I can mux and join MP4 streams.
      Which I can't, currently. If you can help by providing a description of
      the MP4 format or a sample source code, it should be easy to implement.

    * The scripting language was enhanced with the MS downloader. That makes
      all downloaders supported by YTD scriptable.



  v1.42:

    * New providers:
      - Cloudzilla.to
      - Film.Seznam.cz
      - GameSpot.com
      - Natabanu.com

    * Updated providers:
      - XHamster.com

    * Modified the HDS downloader. GameSpot works fine with this new version.
      I hope other servers will work to, but I have no idea whether this hope
      is justified.

    * A support for HDS protocol (e.g. Seznam.cz).



  v1.41:

    * New providers:
      - 1tv.ru
      - dailymail.co.uk
      - rtl.be

    * Updated providers:
      - Super.cz

    * Fixed the unreadable error message for incorrect scripts in the Unicode
      version.

    * Fixed an incorrect upgrade check in the Unicode version. If a version
      info is not found, the user is informed of this fact in the "About"
      window.

    * Support for the global progress bar in the taskbar icon in Windows 7
      or newer.

    * Key F10 opens the main menu.

    * Ignore the stored location of the main window if it would result in
      the main window being placed outside of the visible screen area.



  v1.40:

    * Fixed a last-minute bug in version check for script definitions :-(



  v1.39:

    * Updated providers:
      - Aktualne.cz
      - CestyKSobe.cz
      - CSFD.cz
      - Facebook.com
      - Vimeo.com

    * Expanded the available script functions.

    * Support for automatic script updates. In all places where YTD updates
      were being checked now the script updates are checked as well. In case
      a newer script is available, it will be downloaded and installed
      automatically.

    * Updated the english changelog.

    * The default configuration file now contains a setting for conversion
      to MP3 (of course, the video will get discarded). You can get the new
      config file by deleting the current one (ytd.xml). Thanks to Jey for
      providing the conversion command.

    * Clicking on the tray icon will always bring YTD's main window to the
      foreground, even if the program wasn't hidden in tray.



  v1.38:

    * Support for script-based definition of providers. The scripts are
      extremely basic at this moment, but you can already define some
      servers with simple streaming. The scripts will be eventually expanded
      to support as much of YTD's functionality as possible. That will solve
      the problem of providers such as iprima.cz, because it will be possible
      to update the definition file very quickly without having to build a
      full version, and it will be possible for you to take part in that.
      The scripts are not documented yet, but you can check the demo scripts
      in ytd-defs.xml and the source code in Source/Base/uScriptedDownloader.pas.

    * New providers:
      - MC2.sk

    * Updated providers:
      - 123video.nl
      - Aktualne.cz

    * Updated the build script.



  v1.37:

    * New providers:
      - Heavy-R.com (porn)

    * Updated providers:
      - CeskaTelevize.cz (thanks qwerty)
      - Motherless.com (porno)
      - YouTube.com



  v1.36:

    * New providers:
      - Novinky.cz

    * CeskaTelevize.cz: Third time in one week I have to update this provider.
      Now we shall see whether it is just a webmaster who can't decide about
      his URLs or a malicious intent which will force me to implement a
      distributed solution. It won't be that difficult.



  v1.35:

    * Updated providers:
      - 3news.co.nz
      - CeskaTelevize.cz (author: secret)

    * Verified the build script. Again it works for all Delphi versions I
      can access as well as with FreePascal 2.6.2.


  

  v1.34:

    * Updated providers:
      - CeskaTelevize.cz (author: secret)
      - YouTube.com (author: mandel99)
      Thanks to both of you.



  v1.33:

    * Removed the forgotten debug code in the YouTube downloader.



  v1.32:

    * Updated providers:
      - Blip.tv

    * YouTube.com:
      - Support for the VEVO streaming scheme. Thanks to Mandel99 for this.
      - Modified the subtitle support to allow two-letter language codes
        even if YouTube uses longer codes. This happens with languages such
        as Spanish which might appear as "es-ES" in YouTube. Former versions
        of YTD needed an exact specification, this version will also work
        if you choose "es". The exact specification is preferred, though,
        so if you set a preference to "en-US" and YouTube lists "en,en-US",
        the "en-US" version will be downloaded.

    * RTMP: If you abort the download or the download fails, the movie will
      be renamed from the temporary filename to the expected final one. In
      the previous versions the movie only got renamed if it downloaded
      successfully. Note that if you kill the application in Task Manager or
      CTRL+C the command-line version, the temporary filename will remain.



  v1.31:

    * New providers:
      - Eyeneer.com
      - Old.Stream.cz

    * Updated providers:
      - iHNED.cz
      - Loupak.cz
      - NebickoVPapulke.sk
      - PornTube.com
      - Tyzden.sk
      - Vimeo.com

    * iDnes.cz: Support for multiple videos on one page.
      RTMP streaming still doesn't work.

    * Better decoding HTML entities into czech characters.

    * CLI: Skipped videos (due to already existing file, for example) are
      now reported with a correct error message rather than "Unable to find
      media info page".



  v1.30:

    * Updated Providers:
      - Hrej.cz
      - iDnes.cz
      - MojeVideo.sk
      - PornTube.com
      - Stream.cz
      - Tube8.com
      - ZDF.de

    * CeskaTelevize.cz: Again downloads the highest-quality video. The reason
      why this didn't work correctly was that the hearing-impaired version
      was marked with bitrate 5000, much higher than the other versions.
      YTD now sets maximum bitrate to 4999 unless you explicitly set it to
      another value in the configuration.

    * NovaMov.com: The server is now almost ready for downloads, except that
      I have no sample video to finalize the downloader.

    * Stream.cz: Works again. Servers which were dependent on Stream.cz but
      no longer use it were removed: HudebniVideoKlipy.cz, Mixer.cz, 
      Novinky.cz, Sport.cz, Super.cz.

    * If YTD encounters an existing file and asks what to do about it, the
      save dialog always opens in the file's directory. In the older versions
      it might have opened on the desktop, if you didn't specify a download
      directory.



  v1.29:

    * New providers:
      - NRSR.sk
      - PornTube.com
      - TVNoviny.sk
        - This is an extremely ugly hack, but seems to work.
        - You must provide the passwords and tokens in the Markiza.sk
          configuration.
      - Vine.co

    * Updated providers:
      - iDnes.cz
      - iHned.cz
      - RTVS.sk
      - XHamster.com
      - Zdf.de

    * Barrandov.tv:
      - The provider now uses a completely different streaming service, which
        uses HTTP protocol and doesn't need the secret token anymore.

    * YouTube.com:
      - Updated playlist support, e.g.
        https://www.youtube.com/playlist?list=PLwKJlrLDPPOGNiFfpbcyQ385DBse_5FVB
      - Many videos fail to download with error code 403. This is caused by
        a new streaming system which I wasn't able to decipher yet.

    * Program now compiles under Delphi XE4.



  v1.28:

    * New providers:
      - NaHnoji.cz
      - RTVS.sk
      - TV.HNOnline.sk

    * Updated providers:
      - Beeg.com
      - CeskaTelevize.cz



  v1.27:

    * Nova.cz: RTMP videos work fine, as long as you take case to locate the
      correct password for the resolver (seems to change more often than
      usually). Silverlight videos do not work, possibly due to some 
      incompatibility with MSDL.

    * Stv.sk: Works fine now.

  
  
  v1.26:

    * Updated providers:
      - Hrej.cz
      - Koukni.cz
      - Pornhub.com
      - Rutube.ru

    * Joj.sk: Works again. Note that the sub-sites such as mamaozenma.joj.sk
      now use the main module and as such they need the subdomained URL, not
      the older second-level domains (mamaozenma.sk etc.).

    * Stv.sk: YTD itself can handle the provider, but unfortunately the server
      seems to be incompatible with the current RTMPDUMP and for that reason
      only a "playback stopped" video gets downloaded.

    * VideoPortal.sk: Support removed, because the Joj.sk movies are now
      supported directly by the Joj.sk module. If there are any non-Joj.sk
      movies, they never worked anyway, and apparently nobody missed them.

    * The RTMPDUMP library updated. This might cause regressions with servers
      based on the RTMP protocol. Please let me know if you notice any.

    * Fixed the Byte-order-mark in the Unicode version. It was sometimes
      working incorrectly e.g. with YouTube videos' subtitles if they were
      being converted to .srt format.



  v1.25:

    * Updated providers:
      - ZAKTV.cz (formerly R1ZAK.cz)

    * Joj.sk
      - Moved to the RTMP protocol.
      - I still don't know how to detect the server, but it seems that it
        doesn't matter anyway (that all servers contain the same content).
        If necessary, you can force a server, e.g. "n06.joj.sk", in the
        configuration.



  v1.24:

    * New providers:
      - DansMovies.com (porn)

    * Updated providers:
      - Facebook.com
      - RozzlobeniMuzi.com
      - SoundCloud.com
      - YouPorn.com
      - YouTube.com

    * Stv.sk: YTD will now find the required parameters, but the download 
      itself doesn't work: instead of the requested video you will get a short
      stream about the trasnfer being aborted. I don't know why.



  v1.23:

    * New providers:
      - Animacek.tv (requires a token)

    * Updated providers:
      - CSFD.cz
      - VKontakte.com (fixes Serialycz.cz and others)
      - YouTube.com

    * Changed the way configuration is written to disk: Now it will get stored
      in a temporary file and that is then renamed over the old configuration.
      This should decrease the probability of damaging the config file.



  v1.22:

    * Nova.cz: 
      - Fixed a forgotten debug print, which crashed any download in the GUI
        version.
      - Support for Voyo+. The movies download, but I can't verify that they
        also play, because they are DRM-protected and I don't own the key.
        I would welcome a thumbs up (or down) from someone who does.



  v1.21:

    * New providers:
      - BritishPathe.com
      - HokejCb.cz
      - MentalZero.com (porn)
      - MULitvinov.cz
      - Play.fm

    * Updated providers:
      - iDnes.cz
      - MediaSport.cz
      - RuTube.ru
      - Sibnet.ru
      - Smotri.com

    * CeskaTelevize.cz: Removed the code from late 2011, which required a token
      and seems not to be relevant anymore. This made some current videos work.

    * Nova.cz: 
      - Many movies from Nova's subpages, such as poklicka.nova.cz, 
        hlascz.nova.cz or poker.nova.cz, are working now. You need to provide
        an config password to YTD's configuration (see the GUI or the config
        file's <config_password>) so that YTD can decrypt the video's config
        files.
      - Note that the secret password and the config password are two very
        different things! The secret password is used by the resolver to build
        a video's URL. The config password is used by Nova's subpages to 
        decrypt the input parameters for the resolver. The config password is
        not needed for regular Voyo videos.
      - Note: Voyo+ still isn't supported.



  v1.20:

    * New providers:
      - Gordon.ura.cz
      - JenProZeny.cz
      - Koukni.cz
      - VCTV.cz

    * Updated providers:
      - GameAnyone.com
      - SoundCloud.com
      - TVcom.cz
      - Zakulisi.cz

    * CeskaTelevize.cz: Now downloads both subtitled and un-subtitles videos.

    * Joj.sk: Now downloads movies which were recently moved from their own
      domain to a Joj.sk subdomain (FarmarHladaZenu, MamaOzenMa etc.) as well
      as movies which always used Joj.sk subdomains (e.g. Panelak).

    * RockstarGames.com: Support for GTA IV.



  v1.19:

    * Updated the signing certificate.

    * New providers:
      - Own3D.tv
      - Polar.cz
      - SchoolOfCare.ru

    * Updated providers:
      - B-TV.cz
      - Facebook.com
      - Hrej.cz
      - PornHub.com
      - Tube8.com
      - Tyzden.sk

    * CeskaTelevize.cz: Added support for subtitles. It may happen that some
      videos won't download at all - in that case, disable subtitle download
      in the CT's configuration and try again.

    * Hasici150.tv: Added support for RTMP movies. The old Silverlight-based
      movies should still work, but I can't find any which would play in the
      browser so I can't verify it.

    * iPrima.cz: It will probably die quickly as the Livebox guy updates the
      page setup once again, but if you are quick, you may be able to download
      something...

    * MamaOzenMa.joj.sk: The other *.joj.sk movies should work as well, but
      I haven't tested them.

    * Nova.cz: Completely rewritten. Now both Flash and Silverlight movies
      work. Thanks go to Balutbj for providing a great deal of information
      about how Nova works.



  v1.18:

    * New providers:
      - PlayZone.cz
      - Reflex.cz

    * Updated providers:
      - iPrima.cz
      - Rutube.ru
      - SoundCloud.com

    * Nova.cz: The last update made Silverlight videos work, but stopped Flash
      videos. Now I changed it back to working Flash videos and nonworking
      Silverlight videos, mainly because I don't have a working Silverlight
      example video - all I could find required user account, which I don't
      have. If someone can provide example working videos of all types, I can
      update the downloader to download them all.

    * Zkouknito.cz: Updated.
      Note that the download may not work every time, because the server tends
      to respond from time to time that due to heavy load, video won't be 
      available. This is a server issue, not related to YTD in any way. YTD
      will download that video once the server starts serving it again.

    * RTMP and RTSP handlers will now delete empty video files. Those used to
      be left behind if the handshake between YTD and the server failed. This
      change makes RTMP and RTSP behave like HTTP, which has had a zero-file
      deleting code for a long time.

    * Fixed national character output to the console in the Unicode version.



  v1.17:

    * New providers:
      - Vii.sk

    * CeskaTelevize.cz
      - Fixed an occasinal errorSOAP in the unicode version.
      - Support for partial streams will not happen anytime soon.

    * MojeVideo.sk
      - Updated. Still requires a secret token.

    * Nova.cz (Voyo.Nova.cz)
      - Support for the Silverlight version.
      - May not work 100% correctly, because I couldn't decode how the player
        selects a CDN node.

    * VideaCesky.cz
      - Yet one more embed format supported.

    * The main window's caption now displays whether a Unicode or ANSI version
      is running.



  v1.16:

    * New providers:
      - Azet.sk
      - EuroSeptik.cz
        - Subtitle download is also supported. By default the english subtitles
          will be downloaded, but you can change it in the configuration by
          using e.g. "Přepis, angličtina" or "Přepis, čeština" (the text can
          be found on the video's page; you don't need to provide the whole
          text, an identifying part such as "čeština" will be fine).
      - Matrix-2001.cz
      - MetroProjekt.cz
      - T-Music.cz (thanks to Balutbj)
      - Vikend.Nova.cz (and likely the other Nova.cz subdomains, too)

    * Updated providers:
      - FunnyOrDie.com
      - YouTube.com

    * Removed support for Huste.tv (and Huste.sk), because it requires a login
      and I don't have an account there. If I had an account to play with, the
      support would probably return pretty quickly.

    * Fixed the file deletion issue on invalid downloads - until now, empty
      files only got deleted on "success", but not on actual errors such as
      YouTube's 403 Forbidden.

    * Fixed the filenames generated for RTMP and MS protocols in the unicode
      version. This fixes the random errors while downloading from ceskatelevize.cz,
      which would work every time in the ANSI version.

    * RTMPDUMP updated to version 2012-09-22. The main feature of this version
      is the realtime mode, which sacrifices some speed but greatly improves
      the downloaded file's stability: In the normal mode, RTMPDUMP frequently
      pauses and unpauses the playback, which forces the server to send a large
      chunk of data without bandwidth limitation (which improves speed), but
      unfortunately some servers skip back a few seconds on unpause, which 
      makes the downloaded movie virtually unusable. Realtime mode is turned on
      by default for all providers, but you can turn it off (to get better
      speed) in the provider's configuration.

    * Documentation converted to Unicode enconding.



  v1.15:

    * The default version is now Unicode. Its advantage is that it supports
      national characters of all languages, which makes it easy to download
      from e.g. czech, russian or japanese servers even in US Windows. The
      disadvantages are a slightly larger filesize and the fact that this
      version will not run on Windows older than Windows 2000 (not because of
      Unicode per se, but because Delphi 2009 dropped support for older
      Windows). If you still want to use the ANSI version, you can download
      it from my page and it will then upgrade itself to other ANSI versions.
      But unless you are still using Windows 98, there is little point in
      using the ANSI version.

    * New protocol supported: Adobe HDS. It is used by e.g. RuTube.ru. It
      is based on HTTP(S), over which it downloads multiple separate fragments 
      of a media file and plays them back separately. YTD combines these 
      fragments together into one file. For now only a simplified version of
      the protocol is implemented, but if it proves usable, I may add the
      unimplemented functions (out-of-order packets, support for transfer
      resuming, perhaps one day even multiple fragments downloading at the 
      same time etc.).

      I would like to thank Litew for his invaluable help during betatesting.

    * New providers:
      - eKucharka.net
      - TopRecepty.cz

    * Updated providers:
      - Hasici150.tv
      - Rutube.ru (HDS stream support)



  v1.14:

    * New providers:
      - Ocko.tv
      - TeenMpegs.com (porn)

    * Updated providers:
      - DailyMotion.com
      - RuTube.ru (more supported videos, but not yet HDS)
      - YouTube.com (the unicode version now correctly decodes video name)

    * Fixed a bug which could cause, with some provider such as CeskaTelevize.cz,
      lead to repeated download of the same file.



  v1.13:

    * Experimental cversion with Unicode support available. It should be 
      particularly useful for providers who use exotic languages, such as
      russian or japanese. I would appreciate it if you could download the
      version and let me know whether it behaves correctly, because I would
      like to switch to it sometime soon. For now the ANSI version remains
      the main one, because it is compatible even with Windows 98 while the
      Unicode version will require at least Windows 2000.

    * New providers:
      - Kiwi.kz
      - Myvi.ru
      - Nova.cz (free movies only; token is required)
      - ProstoPleer.com
      - RuTube.ru
      - Sibnet.ru

    * Updated providers:
      - CestyKSobe.cz
      - XHamster.com

    * Added a russian translation from project rStread
      (https://bitbucket.org/litew/rstread).

    * Added a time limitation on playlist-based videos, after which YTD is
      forced to re-download and re-parse the info page. This should make it
      possible to download all parts of multi-part videos with a time-limited
      token, such as this one:
      http://www.ceskatelevize.cz/porady/10120914283-buly-hokej-zive/211471290130045-hc-vitkovice-steel-hc-eaton-pardubice/
      I hope this feature didn't break "normal" multipart videos.

    * The VCL-based GUI version didn't have Play and Explore functions in its
      menu, even though they were programmed in. (This is only interesting to
      those who compile their own YTD, because the official release is using
      WinAPI-based GUI.)

    * The Unicode version now has a special download mode for RTMP- and RTSP-
      based streams, in which a temporary ANSI-compatible filename is used for
      the duration of the download and then gets renamed. The typical usage
      scenario is for Rutube.ru which needs Unicode to get reasonable filenames
      (except if you are running russian version of Windows).

    * If a downloaded file is longer than 2 GB, the total size and percentual
      progress are now correctly displayed.

    * The bugreport function only works for videos whose download couldn't get
      started. Once a download starts, the ability of YTD to influence it is
      zero - it depends solely on stuff like server stability or your network 
      bandwidth.

    * Once again updated the build script to make it easy to update to any
      version of Delphi. Tested on Delphi 5, 7, 2007, 2009, XE2 and FreePascal
      2.6.0. It is possible to build a x64 version with XE2, but it won't run
      due to some missing library imports which I have no idea where they came
      from.


  
  v1.12:

    * New providers:
      - VideoPortal.sk
      - Viki.com, VikiAssets.com

    * Updated providers:
      - CD.cz
      - eHow.com
      - EuroGamer.cz
      - Metropol.cz
      - Metoo.sk (support for RTMP)
      - RozzlobeniMuzi.com (video titles)
      - Sport.cz
      - Video.Google.com (embedded version)
      - VKontakte.ru (downloads in the highest quality)
      - Overstream.net (prolonged timeout; OverStream is incredibly slow)

    * The GUI version of YTD now runs in a single instance by default; if an
      older instance is running already, it gets activated and the new one
      quits.

    * GUI version now supports command-line arguments. If you plan to use this
      functionality, you have to provide --gui argument (because otherwise the
      presence of CL arguments signals that you want to use the CLI version of
      the program), and then one or more of these:

      -new .... Runs a new instance of YTD, even if an old one is running.
      <url> ... Add URL <url> to the download list. May be used more than once.

    * Shortcuts created by the installer and/or the Config form now always
      use the --gui parameter, forcing YTD to run in the GUI mode.

    * New parameter -nd forces YTD to perform all usual processing, but skip
      the actual download. It may be useful especially for debug or scripting
      purposes, e.g. if you want to add your custom arguments to the RTMPDUMP
      command-line.

    * Fixed a bug which prevented the .part extension from being deleted after
      the download finished (if you enabled using .part in the configuration).

    * Fixed a bug which caused videos larger than 2 GB to be deleted after
      a successful download, reporting that no data was downloaded.
      Note: With larger than 2 GB files the progress still doesn't show the
      total size of the video. That requires more significant fixes in the
      Synapse library.

    * Fixed a crash on startup if the configuration file was damaged - YTD did
      report that it will create a new file, but failed to do so.

    * All reports to the console window now use the OEM codepage.

    * Updated the build script to be pretty much universal for all my tools.



  v1.11:

    * New provider: Mixer.cz.

    * Fixed a bug from 1.09, which caused CeskaTelevize.cz to require a token
      even when it was not needed.



  v1.10:

    * Fixed a bug which caused almost all RTMP streams to stop working.



  v1.09:

    * New providers: 
      - Laola1.tv (probably only partial support)
      - NebickoVPapulke.sk
      - Uloz.to (only Uloz.to LIVE)
      - Zvraceny.cz (porn)

    * Updated providers:
      - Rajce.iDnes.cz
      - MojeVideo.sk (requires a token now)

    * YouTube.com: Changed the decoding of the FmtUrlMap object so that it
      will now work regardless of the order of the elements. It might break
      something else, so if you find a video which works in YTD 1.08 and 
      doesn't work in 1.09, please let me know.

    * The Synapse library was updated to release 40. Again, this might break
      something; in such a case, let me know.

    * YTD is now compatible with Delphi XE2 (in 32bit mode). The build script
      was verified to work with Delphi 5, 7, 2007, 2009 and XE2 and also with
      FreePascal.



  v1.08:

    * I am back! Thanks to Balutbj for covering for me while I was indisposed.

    * Updated providers:
      - B-TV.cz
      - Blip.tv
      - CeskaTelevize.cz
      - iPrima.cz
      - Joj.sk
      - Muvi.cz
      - RozzlobeniMuzi.com
      - Super.cz
      - Vimeo.com

    * Barrandov.tv: If HD version is available, it is downloaded. It's done
      through a rather nasty hack which may not work all the time; you can
      turn it off in the downloader settings.

    * CeskaTelevize.cz:
      1. CT works again.
      2. There's a new configuration option to limit maximum bitrate of the
         downloaded movies. The limit only applies if there are lower-quality
         streams. At the moment CT uses bitrates of 2000, 1000 and 500.

    * Fixed an unwanted interaction between the clipboard monitor code and the
      "copy selected URLs to clipboard" code.

    * YTD can now be compiled by Delphi 7, too.



  v1.07:

    * I didn't actually plan to release this version so soon, as I would have
      preferred to add more new features and fix Nova for good, but an article
      on idnes.cz forced my hand...

    * iPrima.cz: Allowed just about every possible URL now.

    * Nova.cz: Support removed, as Nova stopped their free service and I don't
      have an access to the paid one.



  v1.06:

    * iPrima.cz: Support for Prima Play.

    * VKontakte.ru: Support for movies without HQ version. Better filename
      detection.

    * YouTube.com: Support for "playlist?list=..."-type playlists.

    * Some small changes in filename detection.



  v1.05:

    * New providers:
      - CriticalPast.com
      - Smotri.com

    * Updated providers:
      - EmpFlix.com
      - iPrima.cz
      - MojeVideo.sk (old videos may not work anymore)
      - TN.Nova.cz
      - UStream.tv
      - Vimeo.com (support for HD)
      - YouTube.com (playlists)

    * AutosalonTV.cz
      Support removed because now uses ISM streaming, which sends media as
      a great number of separate video and audio parts. Technically, it is
      possible to download such a video, but it would be unusable.

    * Nova.cz: If an incorrect token is used, it is reported so in the error
      message.

    * VKontakte.ru: Support for vk.com/video_ext.php?...

    * Fixed the naming logic of nested downloaders (such as iDnes.cz, which
      benefits from this change; I hope the other nested downloaders also
      benefit, or at least aren't harmed).

    * GUI: Explore folder now works even for movies which haven't started
      downloading yet or are even unknown to YTD. In such a case, the default
      download directory is explored.



  v1.04:

    * Updated providers:
      - iPrima.cz

    * Updated the source code to compile with Delphi 2009.



  v1.03:

    * Nova.cz: Support for another embedding style.

    * YouTube.com: Support for third-party videos which use a javascript-based
      player setup.

    * Updated the language file.



  v1.02:

    * A bug in Markiza.sk caused an exception on unknown URLs.



  v1.01:

    * New provider: LevelTV.Hrej.cz.
      The provider is supposed to require a password, but in fact it doesn't.
      When this is fixed, you'll need to provide the password in the settings
      dialog.

    * New provider: NHL.com.
      Something gets downloaded, I just don't know if it is what I requested.

    * More new providers:
      - 3news.co.nz
      - Ancensored.com
      - Archive.org
      - Casting.xxx (porn)
      - Gavin.xxx (porn)
      - LenkaFilipova.cz
      - Online.Hokej.cz
      - Zapiks.fr
      - ZlutySnih.cz (porn)

    * DailyMotion.com: The full version now downloads videos marked as adult.

    * KeezMovies.com: Support for the embedded version.

    * MetaCafe.com: HTTP-based streams work again. RTMP-based streams are not
      supported at all yet.

    * More updated providers:
      - FreeCaster.tv
      - JenProMuze.cz
      - Metropol.cz

    * The default configuration file now contains conversion settings for use
      with FFmpeg (http://ffmpeg.org/) (thanks ffmpegmann). The easiest way
      to get a new configuration file is to delete the old one, then will YTD
      create a new default config.

    * Removed the double file extension with some providers ("movie.flv.flv").

    * GUI: The setting to disable subtitle conversion didn't work.



  v1.00:

    * Program name changed to YTD to avoid confusion with about 1000 other
      YouTube Downloaders out there.

    * A number of changes in the source code, but these changes only affect
      comments (due to name and year change), not compiled code.



  v0.99:

    * New providers:
      - AcademicEarth.org
      - TV-Vysocina.cz

    * CeskaTelevize.cz: The new pages require a secure token. You are on your
      own finding it, I cannot provide it for legal reasons.

    * Nova.cz: Works again.

    * Prima-Cool.cz: Works again.

    * Video.Nur.kz: Fixed the filename extension.

    * The universal HTML parser modified to support <param name="movie">.
      That allows a number of websites which link to third-party providers
      (e.g. Topky.sk, Pluska.sk) to work.

    * The MMS/RTSP protocol handler now checks the filesize of the downloaded
      file, and if it is less than 64 KB, it returns an error. The reason is,
      some downloads seemingly succeed, but without actually downloading a
      single frame of a movie.

    * RTMPDUMP updated to the most current version (GIT tag 60218d0af0f4bd683ecdebe49986f188820cf8ce).

    * GUI: The downloader settings no longer show 2 or more pages for providers
      such as YouTube. Now each provider only has a single page.



  v0.98:

    * New providers:
      - BMovies.com
      - B-TV.cz
      - CSFD.cz
      - GamePark.cz
      - GameZone.com
      - Games.Tiscali.cz
      - KanalTurk.com.tr
      - Kinobox.cz
      - Metoo.sk
      - Motherless.com (porn)
      - PlayWire.com
      - Rajce.iDnes.cz
      - RawTube.com (porn)
      - ShackNews.com
      - SteamPowered.com
      - TV2Nord.dk
      - Video.Nur.cz
      - World-Club.net
      - Youtu.be
      - YouTube-nocookie.com
      That makes a grand total of 250 supported providers.

    * CeskaTelevize.cz: CT24 works again.

    * MegaVideo.com: Support for embedded links.

    * Rozhlas.cz: Works again.

    * YouTube.com: Updated the format list used by YouTube. That should fix
      the problem with movies being downloaded with an incorrect extension.

    * Lite version: A long time ago some porn providers made it into the lite
      version and started to spread. Now I removed them and checked all porn
      providers to make sure I got them all.
    
    * RTMP: The default setting for "Live stream" is "disabled" for all servers
      except for CeskaTelevize.cz, Nova.cz, iPrima.cz and Barrandov.tv, because
      it appears that many servers can't work with live streams. I recommend
      deleting the configuration file and let YTD create a new one, otherwise
      you won't get the benefit of this change.



  v0.97:

    * CeskaTelevize.cz: 
      - Reverted the code back to 0.94: Only the first video on a page can be
        downloaded, but at least it works reliably.
      - Some movies with unexpected character combinations in the description
        couldn't be downloaded.

    * Free.Zoznam.sk: Support for MP4-format videos.

    * iPrima.cz: Relaxed URL-format requirements so more videos work.

    * KeezMovies.com: Works again.

    * RedTube.com: Support for both HQ and LQ videos.

    * TV7.cz: Works again.

    * TVcom.cz: Relaxed URL-format requirements so more videos work.

    * XHamster.com: Support for both HQ and LQ videos (pre-0.96 versions only
      supported LQ, 0.96 only supported HQ, 0.97 supports both; if there are
      other formats, they don't work because I don't know about them).

    * CLI: Instead of the content URL, a command-line for WGET, RTMPDUMP or
      MDSL is displayed.



  v0.96:

    * New providers:
      - 4TV.cz
      - VideoBB.com

    * CeskaTelevize.cz: 
      - The downloder didn't respect the "Live Stream" setting, which lead to
        unnecessarily jerky playback.
      - Cleaned up the detected video name.
      - Support for CT24 pages with multiple videos. Unfortunately, right now
        these get downloaded into the same-named file (so don't use the "skip"
        or "always" overwrite modes).

    * iPrima.cz: Updated to match current page code.

    * Nova.cz: Updated to match current page code.

    * XHamster.xom: Updated to match current page code.



  v0.95:

    * New providers:
      - FarmarHladaZenu.sk
      - HejbejSe.tv
      - Metropol.cz
      - Osobnosti.cz

    * Blip.tv: Works again.

    * CeskaTelevize.cz: Works again.

    * iPrima.cz: Provided that a page http://prima.stream.cz/<id> exists,
      a yet higher quality video may be downloaded.

    * Stream.cz: Support for videos in user profiles:
      http://www.stream.cz/profil/seznam.cz/safranjan?video_id=604024

    * All RTMP-based downloaders now have a setting for Live Stream mode.
      The Live Stream mode is slow (approximately real-time) but far less
      likely to download damaged than a non-Live Stream. The default setting
      is enabled Live Stream, but it can be disabled in both the GUI and the
      XML configuration (see <live_stream> in the documentation).



  v0.94:

    * Nova.cz: Updated the RTMP-based version to current format. You will need
      to provide a secret password used by the server to authentize approved
      players. For legal reasons I cannot reveal the password or comment on
      how to find it. But if you find it on your own, you can enter it into
      Nova.cz's downloader settings (F9 in main form) or manually into XML 
      configuration (see the documentation for details).
    
    * Experimentally changed downloading mode to "live stream" for Nova.cz, 
      iPrima.cz and iPrima.cz/showjanakrause. This will slow down the downloads
      to approximatelly real-time, but it *may* remove the skipping that's been
      plagueing YTD for some time now. Please let me know if the setting helped
      - if it did, I will provide a user-selectable "live stream" option for
      all RTMP-based providers. Thank you.

    * Updated RTMPDUMP_DLL library to version 30.9.2011 (GIT hash
      60218d0af0f4bd683ecdebe49986f188820cf8ce).

  
  
  v0.93:

   * New providers:
      - 8teenXXX.com (porn)
      - Huste.sk
      - MamaOzenMa.sk
      - MojePorno.sk (porn)
      - OK-Team.cz
      - PicSpoon.com
      - VeeHD.com
      - Video.Google.com

    * EuroGamer.cz:
      - Support for subtitle download and conversion to .srt.

    * iDnes.cz:
      - Fixed http://zpravy.idnes.cz/drabova-radiace-v-podoli-je-zvysena-tisickrat-zdroj-tam-muze-byt-roky-12b-/domaci.aspx?c=A110929_111532_domaci_jj
    
    * iPrima.cz:
      - With some videos, which were hosted on Stream.cz but didn't have a
        dedicated page there, the default (low) quality version was downloaded,
        not HQ.
      - Support for Show Jana Krause archives. There is no way to download one
        episode; instead, all episodes in an archive download sequentially.
      - Livebox.cz-hosted media (including Show Jana Krause) tend to skip back 
        every few seconds. There is nothing I can do about that.

    * Markiza.sk:
      - Fixed names for videos such as http://video.markiza.sk/archiv-tv-markiza/bez-servitky/68688.
        Note that the "old" naming scheme is actually more accurate, this fix
        basically corrects a deficiency in Markiza.sk itself.

    * GUI: Experimental fix for non-translated error messages in download
      threads.

    * GUI: Fixed an EListError exception when exploring a folder without 
      actually having selected a video.

    * GUI: Fixed a non-working media playback, folder explore and some other
      functions, in case a destination directory was selected (these functions
      worked fine in the default settings with unset destination directory).



  v0.92:

    * New providers:
      - EuroGamer.cz
      - ILikeBike.cz
      - R1ZAK.cz
        - Note: It is not possible to select a particular movie; instead, all
          available will be downloaded one after another.

    * Updated providers:
      - CSmaTalent.cz, CSmaTalent.sk
      - Facebook.com
      - iDnes.cz
      - MediaSport.cz
      - Music.Stream.cz
      - TN.Nova.cz

    * Hasici150.tv: Doesn't work at the moment, because I can't find a single
      video which would play in the browser. The downloader is ready, but I
      need that one sample to finish the work.

    * iPrima.cz: Support for the new storage provider Livebox.cz. Old movies
      (stored at Stream.cz) still work, of course.

      A change of providers allowed YTD (even old versions) to download Show 
      Jana Krause, which seemed to be impossible to download before.

    * Particka.Markiza.sk: Support for multi-part videos.

    * VideaCesky.cz: Support for subtitles for http://www.videacesky.cz/reklamy-reklamni-spot-video/super-heineken
      Improved support for videos hosted on VideaCesky.cz itself.
      Improved support for pages with Flash banners (which used to be mistaken
      for videos in older versions).

    * Nested downloaders (e.g. VideaCesky.cz) now display the URL of actual
      content rather than the URL of nested object.

    * Default setting for "download subtitles" was changed to "yes", as written
      in the documentation and as expected by most users.

    * A new option to add ".part" extension to unfinished videos. When the
      download is complete, the movie will be renamed to the actual name.
      The option is disabled by default, because it requires higher access
      rights than the original implementation. You can enable it in the
      configuration dialog.

    * An option to download videos into subdirectories per providers (e.g.
      movies from YouTube would get stored to subdirectory "YouTube.com" etc.).

    * Various minor updates to make the source code more readable and/or 
      manageable.



  v0.91:

    * New provider: HudebniVideoKlipy.cz.

    * Providers updated to work again:
      - CestyKSobe.cz
      - LiveLeak.com
      - Muvi.cz
      - Novinky.cz
      - TnaFlix.com
      - Tube8.com
      - Tyzden.sk

    * Markiza.sk: Support for Particka.Markiza.sk.

    * Stream.cz: Updated to the current player. Added support for direct
      download from CDN cache.

    * TVNoe.tbsystem.cz: Added support for incorrectly encoded XMLs.

    * Vimeo.com: HD video is explicitly requested rather than left on default
      settings.

    * YouTube.com: Support for downloading media over RTMP protocol.

      Updated the algorithm for finding the best video format to allow .webm
      videos even if "avoid .webm format" (see version 0.88) is activated, if
      there is no alternative format available.

      Fixed the support for user pages (such as http://www.youtube.com/user/bemylovepenguin).
      At the moment I am not sure if all movies are downloaded or just the
      newest 25 - I need a 50+ movie page as a demo.

    * Updated the misleading error message "Download of this content is not 
      implemented" to properly signalize that while the download should work,
      it didn't.

    * Added more descriptive error messages to RTMP stream downloads (extracted
      from the RTMPDUMP log file).

    * GUI: Changed the startup sequence in the default mode (without the --gui
      argument): the behavior of version 0.87, which launched a new instance
      of YTD and killed the old one (in order to detach from the console) is
      only applied if YTD was actually started from a console application.
      (This should not be visible to the user in any way, but it might appear
      a bit safer to paranoid security software).

    * GUI: Fixed the incorrect behavior of hotkeys in secondary forms (e.g.
      if CTRL+V was pressed in the Options form, it started a download of
      clipboards's contents in the main form rather than enter the contents
      of clipboard into the focused editbox).



  v0.90:

    * YouTube.com: Updated to the yesterday's new player.



  v0.89:

    * Removed the forgotten detailed logging of RTMP streams. Please clean up
      your temporary folder.



  v0.88:

    * Nova.cz: Support for the new experimental Silverlight-based media player.
      The old player is still supported (I hope), because some movies still
      use it.

    * YouTube.com: In the downloader options you can now disable support for
      container .webm (YouTube's new default container).



  v0.87:

    * Barrandov.tv: Support for the new player. In order to download from
      Barrandov.tv, you will need to find its Secure Token and enter it into
      YTD's configuration (see the configuration settings in the documentation
      or the new user interface to configuration settings as described below).
      Don't ask me where to get the Token, for legal reasons I won't answer
      (while I don't think it would violate the law for me to do so, I am not
      willing to risk a lawsuit).

      Thanks Killerman for discovering the required parameters.
    
    * Cas.sk: Added support for several new types of embedded videos.

    * CeskaTelevize.cz: Fixed the missing extension in filename.

    * DrsnySvet.cz: Support for media hosted directly on the server.

    * iPrima.cz: Works again. I am not sure YTD downloads the highest-quality 
      version - if it does not, please let me know.

    * SportStream.cz: Updated to support SportStream.Tiscali.cz.

    * New distribution archive: Until now a ZIP archive was used to distribute
      YTD. Unfortunately, too many people failed to unpack it properly, running
      only the .exe file without the supporting DLLs and then wondering why
      the downloads don't work. Since this version a new .exe-based archive is 
      used, with easy installation form available.

      For the advanced users: You don't need to use the GUI installation. The
      archive is simply a self-extracting 7-zip file which you can unpack
      manually, then manually create the required shortcuts. Basically, this
      is all the GUI installation does, anyway.

      You can run the distribution archive straight away. The GUI installation
      form offers a button to start YTD without installation, and you can also
      start it with proper command-line arguments - either regular arguments
      of the CLI version, or --gui to run the graphical version.

      You can find more details under "Distribution archive" in the docs.

    * The new distribution model also provides support for automatic upgrades.
      In the GUI, all offers to download the newest version were amended to
      offer a choice between a download (just like before) and an upgrade.
      Note that the upgrade requires a restart of YTD, and thus will force all
      transfers to stop.

      You can also upgrade the program from the command-line with argument -u.
      YTD will download and perform the upgrade, returning the result as an
      errorlevel. Please note that due to technical reasons, if you run the
      upgrade from a script, you should follow it with a delay of about 0.5
      second, to allow proper overwriting of the files.
       
    * GUI: Added support for graphical editor of each downloader's settings:
      In the configuration dialog (F9) is a new tab "Downloader settings",
      where you can specify settings for each particular downloader more
      comfortably than using the old method of editing the XML file. If a
      downloader doesn't appear here, it has no configuration options.

      When you start YTD without any command-line parameters, a new process
      is spawned and the old one quits immediately. This slightly slows down 
      the startup, but on the other hand frees the caller's console (if you
      start YTD from a console program, e.g. CMD or FAR Manager). You can
      still get the previous behavior (direct start without any new processes)
      by running the CLI version of YTD, by starting it from Delphi IDE (for
      debugging purposes) or by using the command-line argument --gui.

      Fixed the bug which prevented creation of shortcuts on the desktop and
      in the Start menu.

    * RTMPDUMP_DLL library updated to version 2.4 (GIT date 20.7.2011).
      This version supports Flash 10 handshake, which should solve bug
      "HandShake: Type mismatch: client sent 6, server answered 9" with
      many recently updated servers.

    * Fixed several incompatibilities with Delphi 2009 and FreePascal.

    * Updated the slovak translation (V. Kubala).



  v0.86:

    * CeskaTelevize.cz: Forgot to remove the detailed log file, which grew
      several times larger than the video itself. Also fixed the multipart
      movies to work with the new player.



  v0.85:

    * CeskaTelevize.cz: Works again.

    * The GUI version of the application remembers its window position and
      size and the column widths, too.



  v0.84:

    * New provider: Agresori.com.

    * New provider: FreeVideo.cz (porn).

    * New provider: G4TV.com.

    * New provider: iViewTube.com.

    * New provider: SoundCloud.com.

    * New provider: Ted.com.

    * Bomba.cz: Support for videos with entity-encoded URLs.

    * Music.Stream.cz: Works again.

    * Shufuni.com: Works again.

    * XTube.com: Works again.



  v0.83:

    * CeskaTelevize.cz: Fixed the bug described in the previous version.



  v0.82:

    * New provider: Hell.tv.

    * New provider: JenProMuze.cz (contains porn).

    * New provider: MachoVideo.com (contains porn).

    * New provider: Metoo.cz.

    * New provider: Muvi.cz.

    * New provider: NovaMov.com.

    * New provider: PornoZdarma.cz (porn).

    * New provider: TheYNC.com (not porn per se, but certainly adult-only).

    * CT24.cz: Support for http://www.ct24.cz/regionalni/125040-v-kralupech-zrusili-jesle-rodice-s-tim-nesouhlasi/.
      It is likely that this fix breaks some URLs which used to work before;
      please let me know if you find such URLs, and until I write a proper
      support, download them using YTD version 0.81. I can't write a perfect
      solution at the moment, unfortunately.

    * iDnes.cz: Support for videos in regular pages, not just video.idnes.cz.
      Make sure you properly escape the URLs when downloading from the 
      command-line.

    * Joj.sk: Support for videos with their own subdomain ("Ano, šéfe", "Nové
      bývanie" etc.).

    * PornHub.com: Updated to the current page code.

    * SerialyCZ.cz: Support for additional video embedding code.



  v0.81:

    * New provider: Bahnorama.com.

    * New provider: Cesnet.cz.

    * New provider: Clevver.com.

    * New provider: Dokumentarni.tv.

    * New provider: FreePornoZdarma.cz (porn).

    * New provider: News.BBC.co.uk.

    * New provider: Serial-Online.cz.

    * New provider: TVLux.sk.

    * CeskaTelevize.cz: Support for Hyde Park and similar pages.

    * CestyKSobe.cz: Fixed the bug "Downloader is not prepared".

    * iPrima.cz: The highest-quality video is downloaded, even if the server
      prefers a lowe-quality one.

    * Joj.sk: Works again. Note that it may not work for all videos, as the
      streaming server is hard-coded and may not be correct in all cases.

    * Nova.cz: Updated to work with current page structure.

    * Music.Stream.cz: Currently doesn't work.

    * VideaCesky.cz: Updated to work with another form of nested downloader.

    * YouTube.com: Support for URLs in form of http://www.youtube.com/watch_popup?v=b5AWQ5aBjgE.

    * Zakulisi.cz: Removed the old debug code, which caused that the same
      video was being downloaded for all URLs.

    * Reorganized the documentation: The list of supported providers was moved
      to file providers.txt.

    * Fixed the command-line version to show downloaded size for videos with
      unknown total size (until now, it didn't display anything).

    * The ENTER key and/or double click on a downloaded movie plays this movie
      in the default media player. (The double click used to work before, but
      only in the VCL version of YTD.)

    * CTRL+E key opens the folder into which the selected file was downloaded.

    * In case an error occurs when loading the configuration file, YTD will
      notify you of this problem and will create a new config file.



  v0.80:

    * New provider: HardSexTube (porn).

    * New provider: Zmozek.cz.

    * CeskaTelevize.cz, CT24.cz: Fixed to the current player code. All videos
      in all pages should work.

    * XHamster: Updated to the current player.

    * Fixed bugs when compiling with Delphi 2009.



  v0.79:

    * New provider: CKKlic.cz.

    * New provider: Multimedia.vse.cz.

    * New provider: VKontakte.ru.

    * New provider: ZDF.de.

    * CeskaTelevize.cz: Support for multi-part videos (e.g. Sama doma 2011-
      03-29). Fixed the bug which caused downloads of low-quality streams
      instead of high-quality (the bug was in YTD, not the server as I
      previously thought).

    * Markiza.sk: Support for doma.markiza.sk.

    * SerialyCZ.cz: Support for another way of embedding video.

    * VideaCesky.cz: Support for direct-linked videos. Support for videos
      incorrectly linked with a space at the beginning. Support for converting
      subtitles to .srt format (enabled by default, but can be turned off
      in the configuration file - see documentation for details).

    * ZkoukniTo.cz: Added support for embedded URLs.

    * Modified the support for subtitles with servers linking to a third-
      party content (e.g. VideaCesky.cz): Now the linking server's subtitles
      are downloaded first and linked server's only if the former don't
      exist; until this version it used to be the other way around.

    * Changed the way automatic HTML parser (see version 0.77) works in
      conjunction with clipboard monitoring (version 0.71): Until now it
      led to unexpected creation of configuration options.

    * Started the clean-up of YTD's code.



  v0.78:

    * New provider: CNBC.com.

    * New provider: i-Concerts.com.

      - Only the free version without playlists for now.

    * New provider: PracticalMethod.com.

    * New provider: Proglas.cz.

    * New provider: VideoPortal.sf.tv.

    * Activated "generic" downloaders for protocols RTMP (RTMPE, RTMPT, RTMPTE)
      and MMS (MMSH, RTSP). This means that direct URLs for these protocols
      (e.g. "mms://netshow.play.cz/proglas/audio_15681.wma" or "rtmp://iconcerts.infomaniak.ch/icpreview/mp4:trk-09-black_kids_nme_awards_shows-001_site_16-9-2500.mp4")
      can now be entered into YTD and the program will download them (if
      permitted by the server). Basically, YTD behaves like an extremely
      simplified version of RTMPDUMP (or MSDL) for these URLs.

      There are two major disadvantages of this approach:
        1) You won't get nice video names. The files are stored under the
           internal name selected by the provider.
        2) If a provider's server requires additional parameters, such a movie
           can't be downloaded this way. Use a full RTMPDUMP (MSDL) in these
           cases, because these tools can accept the required parameters.

      The major advantage is that this functionality enables downloads from
      servers which are not directly supported by YTD (e.g. Proglas.cz).

    * Barrandov.tv: Downloads don't work any more, because the provider
      switched to a new player and encrypted communication, which prevents
      me from discovering which requests the server expects. Until someone
      finds out the parameters or shows me how to set up RTMPSUCK (part of
      the RTMPDUMP project) to get to the unencrypted data, the provider will
      remain non-working.

    * CeskaTelevize.cz: Updated "porady" (www.ceskatelevize.cz/porady).

    * Zakulisi.cz: Fixed the random "Access Violation" bug, I hope. It seems
      to be a bug in Delphi 5, which manifests in certain kinds of string
      operations and overwrites memory it shoudln't. My fix seems to work,
      but as the bug appeared randomly, I have no way of reliably testing the
      fix.

    * Updated the slovak translation (thanks to V. Kubala).



  v0.77:

    * New provider: DancingBear.com (porno).

    * New provider: Denik.cz.

      - All regional variants are supported, too. Both video and audio are
        supported.

    * New provider: FunnyOrDie.com.

    * New provider: iDnes.cz.

      - The provider is implemented through another dirty hack: the streaming
        server is entered as a constant string in the code, because the
        officially requested server actually doesn't work.

    * New provider: PBS.org.

    * New provider: Sefka.cz, Sefka.sk.

      - Adding future Prima-Joj joint projects will be a trivial matter.

    * New provider: Sme.sk.

    * New provider: Zakulisi.cz (porn).

    * FreeCaster.tv: In addition to HTTP streams, RTMP streams are also
      supported (some movies are streamed over one protocol, others over the
      other).

    * N-Joy.cz: Added support for audio download, for Right Now (both audio
      and video), and for MMS/RTSP based streams (this last features hasn't
      been tested yet, though, because I only found one such video and it
      didn't work even in the browser).

    * Nova.cz: Movie "Ordinace v růžové zahradě 2, 250. díl" (and perhaps
      some others) works now. The reason it hadn't worked was, there isn't
      a high-quality version of the movie online, but the server still 
      incorrectly reports that it was downloaded successfully. I solved the
      issue by two changes:

      1. You can now force YTD to download low-quality videos by modifying
         the configuration file. Search the documentation for <nova_cz> for
         details.

      2. If "dirty hacks" are turned on (which is true in my releases), YTD
         tries to detect this situation and automatically download the low
         quality version. Note that this *really* is a dirty hack, so don't
         be surprised if it behaves strangely (e.g. the movie's filename still
         has an .mp4 extension, even though it is in fact a .flv).

    * Servers which work again after their pages changed:
      - Hasici150.tv.
      - MTV.com (doesn't actually work, see the "handshake" note below).
      - RedTube.com (porn).
      - TotallyCrap.com.
      - UStream.tv.
      - WordPress.tv.

    * Temporarily non-working servers:
      - CrunchyRoll.com: requires Flash autentization.

    * An increasing number of servers which use the RTMP protocol can't be
      downloaded anymore - they write warning "HandShake: Type mismatch: 
      client sent 6, server answered 9" into the log file and then quit with
      error "handshake failed". This is caused by the fact that while these
      servers require Flash version 10 now, RTMPDUMP only supports version 9
      (see http://stream-recorder.com/forum/rtmpdump-does-not-start-error-handshake-type-t8603.html).
      Until RTMPDUMP is updated with Flash 10 support, nothing can be done
      about this problem.
      
    * Support for an automatic application of HTML parser to unknown URLs: If
      you tell YTD to download an unknown URL, the program will try to find
      known URLs as if you added the address using -s parameter (button "Add
      URLs from HTML page"). That adds support for servers such as Zive.cz,
      Vlaky.net and many others which embed other provider's video players.
      The old behavior (YTD tries to locate a downloader and if it fails, it
      returns an error) can be turned on by using argument -ah-, setting the
      <auto_try_html_parser> option in the config file, or in GUI using the
      appropriate checkbox in the Settings.

    * Fixed the duplicated file extension when using nested downloaders.

    * When task-switching using ALT+TAB, a correct icon is displayed.

    * Support for YTD version numbers larger than 0.99.

    * Recompiled the RTMPDUMP_DLL library to use a smaller (slightly butchered)
      version of PolarSSL. That reduced the binary by about 27 KB while keeping
      all relevant functionality (I removed mostly debug stuff, plus a few
      ciphers which are not used by RTMPDUMP anyway). If you do encounter a
      problem (other than the "handshake problem" above), you can use the old
      RTMPDUMP_DLL from the older versions of YTD. But I don't expect any
      trouble - I tried all RTMP-based servers, and except for the handshake
      issue, they all worked fine.

    * The main (portable) configuration file YTD.XML is now first searched for
      in the current working directory, and only if not found, the file from
      YTD.EXE's directory is used. This change enables you tu use multiple
      configurations without having to have multiple copies of YTD's executable
      files as well. There was no change for the secondary (non-portable)
      configuration file, it is still located in the user's profile directory.



  v0.76:

    * CeskaTelevize.cz: The change in 0.75 blocked support for the alternative
      media sources such as the old iVysilani.



  v0.75:

    * CeskaTelevize.cz: Added support for movies which run in an IFRAME
      (e.g. Diagnoza).

    * YouTube.com: Support for videos, which have playback restricted to 
      certain sites by the copyright owner (this is the case with many music
      clips).

      Playlist support fixed to work with current page layout.

    * Fixed the non-working CTRL+C (Copy URLs to clipboard) in the GUI.



  v0.74

    * New provider: 123Video.nl.

    * New provider: Hrej.cz.

      - Some movies are hosted on third-part servers, e.g. YouTube. These
        can't be downloaded directly, but work if you use the "Add URLs from 
        HTML page" function.

    * New provider: MojeTelevize.cz.

      - The downloader is generic enough to work with all (hopefully) projects
        hosted at MojeTelevize.cz, e.g. Adra.MojeTelevize.cz.

    * New provider: Sport.cz.

    * New provider: TV4Play.se.

      - Only free (non-paid) content is supported.

    * New provider: Video.Tiscali.cz.

    * CeskaTelevize.cz: Changed the download to run in "live stream" mode
      by default. The "live stream" mode takes a much longer time to download,
      but the resulting video files seem to play OK. It is possible to switch
      to "download as file" mode, which is much faster, but until the server
      side is fixed, will result in faulty video files. The configuration
      option is decribed in the documenation (search for <live_stream>).

    * Joj.sk: Fixed to the current player format.

    * Markiza.sk: Support for multipart videos (e.g.
      http://video.markiza.sk/archiv-tv-markiza/parti269-ka/54516).

    * StreetFire.net: Temporarily non-functional.

    * YouTube.com: Updated the subtitle converter to use a proper decimal
      separator for seconds (should be a comma, was a dot).



  v0.73

    * CeskaTelevize.cz:

      1) Bad news: While the new web layout is supported, the downloaded
         movies are worthless, thanks to the completely insane implementation
         of Czech TV. Basically, I can ask for any stream I like, and the 
         server will confirm that it will send it to me, but in fact it will
         send a different stream - and while sending, it will manipulate its
         parameters as it sees fit. I have seen claims that this behavior is
         in fact a feature and not a bug, but as far as YTD is concerned, it
         only means one thing: Until Czech TV fixes it, YTD won't be able to
         download its streams properly. There's no point in asking me to do
         anything about it, because the sad fact is that I can't do anything
         that I didn't do already. Only two better solutions exist: One, CT
         will fix its servers. Two, someone else who understands the working
         of CT's servers better than me, will submit an updated source code.

      2) Good news: Fortunately, the old iVysilani is still working, on page
         http://www.ceskatelevize.cz/ivysilani-jako-driv/ (thanks to Pepa
         and Pája for informing me). This version of YTD supports these new
         (old) addresses.

      3) More good news: CT also provides some of its movies to Stream.cz.
         As that server streams over good old reliable HTTP and is supported
         by TD, you can download the movies there, too.



  v0.72

    * New provider: 1hd.ro.

    * New provider: DotSub.com.

    * New provider: Music.Stream.cz.

    * New provider: RockstarGames.com.
      Note: This provider requires that HTTPS is used. Because of that, you
      need to have the OpenSSL libraries LIBEAY32.DLL and SSLEAY32.DLL in
      your path.

    * New provider: SerialyCZ.cz.

    * New provider: SportStream.cz.

    * New provider: Tyzden.sk.

    * CeskaTelevize.cz: Updated to work with the new version of iVysilani.

    * CestyKSobe.cz: Added support for an alternate video player code, as
      seen at http://cestyksobe.cz/novinky/novinky/544.html.

    * iPrima.cz: Support for movies which are hosted at Stream.cz, but don't
      have a dedicated page (e.g. http://www.iprima.cz/videoarchiv/42037).



  v0.71

    * New provider: AdultLoop.com (porn).

    * New provider: BandZone.cz.

    * New provider: DUB.cz.

    * New provider: PrahovaHD.ro (on-demand videos only).

    * New provider: Rtl.nl.

    * New provider: StastneVdovy.cz.

    * New provider: Super.cz.

    * New provider: TVS.pl.

    * New provider: WeGame.com.

    * iPrima.cz: Fixed the video title.

    * Nova.cz: Updated to support the latest changes in the archive.

    * STV.sk: Updated to support current page layout. Note: The server is
      extremely unstable, even for the purpose of watching online rather than
      downloading.

    * Added a new option "Monitor clipboard for downloadable URLs". It is
      turned off by default, but if you turn it on, YouTube Downloader will
      monitor the clipboard for known URLs and add those to the download
      list automatically.

    * If there was no application associated with .xml files for editing
      in your Windows, the "Edit configuration" button didn't do anything.
      Now it opens the configuration file in Notepad.

    * YouTube Downloader has a new icon, created by user KRYSPIN of
      Hofyland.cz. One of the major benefits of the icon is that it scales
      well for all icon sizes.



  v0.70

    * Fixed the Access Violation error while redrawing the download list,
      which appeared in the last version.

    * Fixed the captions of two menu items which didn't match between the VCL
      and the WinAPI version.



  v0.69

    * New provider: AutoSalonTV.cz.

    * Blip.tv: Support for playlists.

      Note: Preparation of a playlist may take a long time (with long playlists
      such as http://thespoonyone.blip.tv) and doesn't provide any visual 
      feedback. Please be patient.

    * Facebook.com: Added support for movies without quality mark.

    * Markiza.sk: Updated to support the new video player.

    * Novinky.cz: Improved support for movies within articles.

    * Significantly improved the "Options" dialog (F9). It can now edit most
      of the configuration options from the GUI, including proxy server
      settings or the ability to turn new version notification on and off.

      Buttons for creating shortcuts to YouTube Downloader in Start menu or
      on the desktop are also available in the Options dialog.

    * Fixed several incompatibilities with Delphi 2009 (only those who compile
      YTD themselves need to worry about this change, since the production
      version is compiled by Delphi 5):

      - Application crashes with Access Violation or other error if the WinAPI
        version of GUI is enabled.

      - Reading of the newest version number never completes.

    * The "Stop" button of the GUI version of YouTube Downloader behaved in 
      fact like "Pause" - it just paused the transfer, not stopped it.

    * The portable mode was rather more prolific than expected - it could, in
      some situations, override the "non-portable" mode.



  v0.68

    * FreeCaster.tv: Fixed to support the new page layout.

    * Novinky.cz: Support for movies within articles.

    * Stream.cz: Fixed to support the new page layout. This also fixes all
      servers which use Stream.cz as their provider, e.g. iPrima.cz or 
      N-Joy.cz.

    * YouTube.com: Subtitles work again.
      Added support for embedded URLs.

    * CLI: More frequent update of the download progress, especially with
      large videos.



  v0.67

    * Fixed non-refreshing download list under Windows 7.



  v0.66

    * Fixed a bug when starting the program under Windows 7.



  v0.65

    * New provider: CD.cz.

    * New provider: ThatVideoSite.com.

    * New provider: WordPress.tv.

    * New provider: Yikers.com.

    * UStream.tv: Updated video title detection.

    * Switched to a new version of GUI, based entirely on the Windows API 
      rather than Delphi's native VCL. Both behave in almost exactly the same
      way, aside from the new bugs, but there are several advantages to the
      API version:

      - It's code is a lot shorter. The distribution archive was reduced by
        about 125 KB, the application itself (before compressing by UPX) by
        almost 400 KB. This saving was my major reason for attempting the
        rewrite.

      - If you have the Common Controls library in version 6.0 or higher (which
        is native to Windows XP, and can be downloaded with the older systems),
        the downloads list won't flicker anymore.

      - It is compatible with FreePascal. In other words, if you want to change
        something in the program and want to keep the GUI, you can do it even
        using only free tools.

      It has several disadvantages, too:

      - It's not nearly as well debugged as the old GUI. As people start using
        it, this issue will eventually disappear.

      - It's not compatible with Delphi 2009 yet. For an unknown reason, the
        downloads list will eat up all available memory very quickly and the
        application will crash afterwards. I wasn't able to find the cause yet.

      If you want to switch to the VCL-based GUI, delete the following line
      from Source\YTD.inc: "{$DEFINE GUI_WINAPI}".

    * Files are now opened in a shared mode, allowing video playback while
      a movie is being downloaded. This function only applies to HTTP-based
      providers.

    * Various optimizations and code cleanup.



  v0.64

    * New provider: MTV.com.

    * GameAnyone.com: Works again with the updated website.

    * KeezMovies.com: Works again with the updated website.

    * Nova.cz: I gave up and allowed URLs with two slashes after nova.cz.

    * SpankWire.com: Works again with the updated website.

    * Slovak language files updated.

    * Fixed a bug with adding a new URL using INS: The URL from clipboard was
      always used, regardless of changes the user may have made in the input
      dialog.

    * Fixed a bug in the default configuration file (which gets created if
      file ytd.xml doesn't exist): conversion to AVI/H264 was defined but not
      user-accessible.

    * Added a check for long filenames. If a filename (including destination
      path) is too long, it will be trimmed to about 250 characters, a size
      commonly supported by Windows in default configuration.



  v0.63

    * New provider: Beeg.com (porn).

    * New provider: Brazzers.com (porn).

    * New provider: Fishki.ru.

      Note: While it is possible to capture movie title from the page, I am not
      sure how to create a valid filename from it without compiling YTD with
      Delphi 2009 (which would have several drawbacks, including program size
      and incompatibility with old Windows). For now the original filename is
      used and the video title is ignored. If you have a better solution for 
      this problem, I will gladly implement it.

    * New provider: Hasici150.tv.

    * New provider: Loupak.cz.

    * New provider: NaStojaka.cz.

    * New provider: NBC.com.

    * New provider: Prima-Cool.cz.

    * New provider: RozzlobeniMuzi.com (some porn).

    * Nova.cz: Media removed from the servers are now detected as such (e.g.
      (http://archiv.nova.cz/multimedia/pribehy-bez-scenare-zivot-na-vlasku-sedmy-dil.html).

    * GUI: The separate icons for different options were removed; instead,
      a brand new Options dialog is available, where you'll find all options
      at one place (that is, all graphically-editable options; there are many
      other options described in the documentation). 
      
      One side-effect of this change is that the graphical version now has the
      same "automatically rename" action to be used if an existing filename
      is found as the CLI version.

    * Notes about compiling from source code were added to the documentation.
      The compile scripts were cleaned up (e.g. it's no longer necessary to
      tell the script which version of Delphi should be used for building).

    * Fixed a bug in AMFString.



  v0.62

    * Fixed a XML component to correctly (as per XML specs) handle character
      encoding. That should fix all filenames with international characters
      (http://archiv.nova.cz/multimedia/foto/okresni-prebor-8-dil-schuze.html).
      This fix may break something else; if you notice such a case, please let
      me know.

    * Found and fixed a cause for a number of "Download to file XYZ was not
      allowed" messages. The message itself remains, because the operating
      system may indeed prevent writing to a file, but now it should only
      appear if the OS is indeed preventing the writes.



  v0.61

    * New provider: RTA.cz.

    * New provider: Sex-Doma.cz (porn).

    * New provider: TN.Nova.cz.
      Note: I couldn't properly decode, how to get a video URL from a given
      article URL. In order to get this provider to work, I had to resort to 
      a very dirty hack, which sequentially tries a number of possible servers 
      to see if it can find the real one. That's slow, unreliable and above 
      all the provider could ban you for this kind of abuse of his servers.

    * New provider: Z1TV.cz.

    * CT24.cz: Support for URL format
      http://www.ct24.cz/vysilani/2010/02/10/10159875412-210411058030210-11:35-milenium/

    * MojeVideo.sk: The requirements for movie URLs were too strict, preventing
      some videos from being downloaded (for example 
      http://www.mojevideo.sk/video/654a/eduard_mila_tomasovi_gen.html).



  v0.60

    * New provider: DrsnySvet.cz (some sources only).

    * New provider: MojeVideo.sk.

    * New provider: Qip.ru (embedded movies only).

    * New provider: Studio-Plus.tv.

    * GameAnyone.com: Support for videos hosted directly on GameAnyone.com.
      This fix also works for any other providers which work through 
      third-party's servers, e.g. VideaCesky.cz or OverStream.net.

    * YouTube.com: Fixed a bug EStreamError which occured on videos without
      subtitles.



  v0.59

    * CeskaTelevize.cz: Support for URLs such as http://www.ceskatelevize.cz/porady/873537-hledani-ztraceneho-casu/207522161510013-filmy-z-vaclavaku/.
      Note that not all pages in this format actually contain a video!

    * MustWatch.cz: Provider moved to a new domain.

    * YouTube.com: Support for downloading in other than highest-available
      quality. There are special settings in the config file that control
      this functionality. Their use is noted in the documentation
      (<max_video_width>, <max_video_height>).

      User pages (http://www.youtube.com/user/titanicpiano14) work again.

      Playlists (http://www.youtube.com/view_play_list?p=90D6E7C4DE68E49E)
      work again.

      Support for subtitles. The first subtitles are downloaded by default,
      but you may select preferred languages and their priority in the config
      file. The subtitles are converted to .srt format by default, because
      YouTube uses a special format, but you can turn the conversion off. See 
      the documentation for details (<preferred_languages>, <convert_subtitles>).

    * Changed the way subtitles are downloaded: Now they are downloaded
      before the movie, not after it. Quite a few other changes were made,
      especially to providers without their own infrastructure (such as
      VideaCesky.cz); please report if you notice non-working subtitles where
      they used to work in previous versions.

      Subtitle support can now be turned on or off either globally or on
      per-provider basis. See the documenation for details (<subtitle_support>).

    * Location of provider-specific settings in the configuration file didn't
      match either documentation or sample config files. Fixed so that reality
      matches both documentation and examples (<modules>).



  v0.58

    * New provider: PrazdninyVTelci.cz.

    * New provider: TubeSSS.com (porn).

    * OverStream.net: Added support for subtitles.

    * PublicTV.cz: Support for multi-part movies (e.g.
      http://www.publictv.cz/cz/menu/3/videoarchiv/clanek-22184-jukebox-s-lenny/1935/)

    * TVcom.cz: Fixed incorrect parsing of title.

    * VideaCesky.cz: Yet another content format supported.

    * YouTube.com: Support for URLs which don't have video ID as the first
      parameter.

    * Subtitle support was rewritten for easy implementation with any provider.

    * MSDL downgraded to version 1.2.7, because I can't remember how I managed
      to compile the newer 1.2.7-r2 on Windows.



  v0.57

    * I forgot the debug code in. It is harmless, but also annoying.



  v0.56

    * New provider: NavratDoReality.cz
        - Note: Only movies hosted directly by NavratDoReality.cz are supported.
          Third-party-hosted videos are not supported.

    * New provider: TV7.cz

    * Another attempt at tackling the occasional baffling error "Download to
      file XY was not allowed."

    * Source HTML file (-s argument) can now be in UTF-8 and UTF-16 encoding,
      too.

    * YouTube Downloader is now compatible with Delphi 2009.

    * The NativeXml library updated to version 3.10. This fixes national
      characters for some providers, e.g. TV Barrandov.

    * Fixed a hidden bug in the build script (wildcards in filenames weren't
      properly expanded before passing to the compiler).



  v0.55

    * Incorrect default value for encoding in TNativeXml caused invalid names 
      in XML-based providers.

    * The Delphi 2009 compatibility fixes caused a strange memory allocation
      bug, which manifested e.g. when downloading from TV Nova. It has been
      fixed, but it is possible the bug may still exist in other parts of the
      program.



  v0.54

    * iPrima.cz: Works again. New URL format supported.

    * Markiza.sk: Support for TalentMania.

    * More code changes that will eventually make YTD compatible with Delphi
      2009. Program can now be compiled by it, but don't bother, since it
      won't work - several key parts need to be rewritten first.



  v0.53

    * Vladimir Kubala (kubalav@gmail.com) created a slovakian translation.

    * New provider: OverStream.net

    * New provider: MustWatch.hztz.cz

    * New provider: CSmaTalent.cz, CSmaTalent.sk

    * VideaCesky.cz: Support for two more methods of embedding videos.

      Unfortunately, some of the movies are difficult to access for most users,
      because the provider happily ignores internet standards and uses invalid
      URLs with characters which shouldn't be there. Some browsers (such as
      Internet Explorer and Opera) then copy these invalid URLs to clipboard,
      preventing YTD from downloading them. Use Firefox, it accepts invalid
      URLs and encodes them to a proper format (such as http://www.videacesky.cz/skece-zabavne-scenky/george-carlin-%E2%80%93-nabozenstvi-je-kravina)
      before copying them to clipboard.

    * The definitive fix will have to wait until I manage to rewrite YTD for
      full compatibility with Delphi 2009.



  v0.52

    * New provider: AlternativaTV.cz

    * New provider: PCPlanets.com
        - The provider should work fine, but it keeps returning a HTTP error
          403 (forbidden). The same error is produced by the flash player
          itself, though, which makes it likely that the problem lies not in
          YTD but rather some bug or country restriction of PCPlanets.com.

    * Modified PerlRegEx to only contain Unicode support if compiled under
      Delphi 2009 and newer. In older Delphi this results in about 80 KB
      reduction of .exe file size.

    * Some under-the-hood modifications that will eventually result in
      compatibility with Delphi 2009+.



  v0.51
    
    * License terms change: YouTube Downloader is no longer distributed under
      the GNU GPL: a careful study of both GPL and the licenses of third-party
      libraries used in the application reveals that I don't have the right
      to release the program under GPL. YouTube Downloader is now being released
      under the "new BSD license", with third-party components (in directory
      Source/Lib) being governed by their own respective licenses. The details
      are described in the documentation.

    * GUI: Converters are now deactivated by default and must be activated in
      the configuration file before they can be used. The reason is, many people
      failed to read the documentation and instead started complaining that
      converters don't work (which was, and still is, expected - converters
      must be configured first). The activation steps are described in the
      documentation.

    * GUI: The conversion failure is now split: You can recognize whether the 
      conversion failed to even start or whether it started but failed to
      finish successfully.

    * GUI: An error message is displayed if you try to add an unsupported URL.

    * CeskaTelevize.cz:
      - Support for advertisments (specifically, skipping them).
      - Support for URLs like: http://www.ceskatelevize.cz/program/10252893246-07.08.2010-08:32-24-prizma.html

    * CT24.cz: Support for URLs like: http://www.ct24.cz/regionalni/87267-vrchlabsky-zamek-ma-vlastni-miniaturu/

    * VideaCesky.cz: Support for movies hosted directly on the server rather
      than on YouTube (e.g. http://www.videacesky.cz/ostatni/ceska-republika-narod-pivaru)

    * MSDL updated to version 1.2.7-r2.



  v0.50

    * Before the first start of the GUI version (that is, when a GUI version
      is stared but no configuration XML file exists), the program will ask
      you several questions in regards of configuration options which influence
      your privacy. Please pay close attention to these questions.
    
    * When starting the GUI, a check for new version is automatically
      performed. If you prefer not to do this check, there is an option
      to turn in off in the configuration. See the documentation for details.

    * Completely rewritten the way options are stored. Instead of the old
      weird combination of INI files and registry, YouTube Downloader now
      uses a XML file. This file can be stored either in the application
      directory or in the user's profile, depending on whether you use YTD
      as a portable application or a regular one. You'll find more details
      in the documentation.

    * Support for conversion or any other operation on successfully downloaded
      movies. The basic usage is described in the documentation in section 
      "Conversion of downloaded file", section "Configuration" provides 
      details on defining your own converters or changing the existing ones
      (search for <converters>).

    * GUI version now has a button for donations, if you feel like spending
      some money to help further development. Don't feel obliged to do so,
      though, the application is and will remain free regardless. It's more
      of a means of tracking how many people find my application useful
      than a source of income (besides, I would have to tax it if too many
      people donate, and I'd rather not have to do that).

    * The GUI version also provides a button for reporting non-working URLs.
      The function requires that you use the newest version of YTD. Before
      reporting an error, please make sure the problem is with YouTube
      Downloader and not your internet connection or the media provider's
      web site (for example, try that the movie plays fine if you try to
      load it in a web browser). Thank you.

      The error reporting is done through a special web form. The required
      fields will be filled in when you open it, but I urge you to fill in
      the description field and, if you want to get a response or in case
      I need more detailed info, an e-mail as well.

    * GUI version now has more detailed error messages.

    * An elusive long-standing bug, present since version 0.12 (though I first
      encountered it while working on version 0.41), which could cause random
      crashes after a download was finished, was found and squashed.

    * New providers:
        - AngryAlien.com
        - Blennus.com
        - Bolt.com (BoltAgain.ning.com)
        - Current.com
        - Dachix.com (porn)
        - DevilDucky.com
        - EmpFlix.com (porn)
        - EVTV1.com
        - Grinvi.com (porn)
        - NothingToxic.com
        - Revver.com
        - SlutLoad.com (porn)
        - Spankwire.com (porn)
        - TnaFlix.com (porn)
        - TotallyCrap.com
        - YouJizz.com (porn)

    * Barrandov.tv: Instead of the old .f4v extension a better .flv is used.

    * Break.com: Support for two variants of links to the embedded version.

    * VideaCesky.cz: Added support for an alternate embedding method, which
      should make previously non-downloadable movies work.

    * PornHub.com: Support for links to the embedded version. Fixed downloads
      of the regular (HTML) version.

    * Another significant change in the source code: I removed the old XML
      parsing component TjanXmlParser2 and replaced it with TNativeXml, which
      is still being developed, supports all versions of Delphi and is more
      more compatible with XML specs. Just like with regular expressions in
      the last version, this change may lead to some non-working providers,
      although I tried most of them and they seem to be fine.

    * YouTube Downloader can once again be built with FreePascal. A guide to
      building YTD is written in Source\build.txt. The build scripts were
      moved to Source, too.



  v0.40

    * New provider: Cas.sk.

    * New provider: MediaSport.cz.

    * Free.zoznam.sk: Video was saved with .php extension.

    * LiveLeak.com: Support for embedded videos (alternate link).

    * MSFotbal.ct24.cz: The original links on the "msfotbal" subdomain no
      longer exist, but you can still get to the videos using standard
      CT24.cz links.

    * Rozhlas.cz: Works again (it's not needed anymore, because the pages now 
      contain direct links to music, but since this provider is supported...).
      Fixed a bug which could lead to unwanted overwriting of files from the
      same page.

    * YouTube.com: Works again, after YouTube changed their pages.

    * GUI version: File-selection dialogs (opening or saving) now use interface
      of your Windows version, rather than the old Windows 98 interface used
      in older versions.

    * Command-line version: Support for result codes (errorlevel). The codes
      are listed in the main documentation.

    * Command-line version: An error in arguments or encounter of a "display"
      parameter (-?, -v, -l) causes YouTube Downloader to stop processing the
      command line and exit.

    * Some size-optimizations of the utility.

    * Fixed saving of unfinished URLs, which didn't work correctly if the
      download list was empty.

    * Switched to a new library for regular expressions. Program now uses
      TPerlRegExp instead of the old DPCRE. While this may cause some providers
      to stop working (I did check many of them, but not all of them), it 
      removed the dependency on PCRE.DLL and it is much more future-proof - 
      TPerlRegExp is still maintained and updated to new versions of PCRE,
      and it officially supports all versions of Delphi, including the new
      ones (2009, 2010).



  v0.39

    * GUI version: The list of unfinished URLs is automatically saved on change
      and loaded when the program starts. In effect, you can now quit YouTube
      Downloader and later continue with downloads where they finished. 
      
      If YTD is used in portable mode (DontUseRegistry=1), the INI file must be 
      writable for this function to work.

    * To facilitate the previous feature, default value for DontUseRegistry
      was changed to 0 - "use registry". If you want to run YouTube Downloader
      in portable mode, you MUST create the INI file and put DontUseRegistry=1
      into it.

    * VideaCesky.cz: Some movies couldn't be downloaded.

    * New provider: Aktualne.cz (Aktualne.Centrum.cz).

    * New provider: AutoTube.cz.

    * New provider: Bomba.cz.

    * New provider: DeutscheBahn.com.

    * New provider: GameAnyone.com.

    * New provider: iHned.cz.

    * New provider: Novinky.cz.

    * New provider: PublicTV.cz.



  v0.38

    * Support for alternate form of URLs for msfotbal.ct24.cz.

    * Updated YouTube support to changes from Jun 17, 2010.

    * GUI: Double click on a downloaded video plays that video in the default
      player (according to its extension).

    * New provider: CestyKSobe.cz



  v0.37

    * Some changes in the code result shortening of the command-line-only 
      version of YouTube Downloader in half - if you disable GUI, the
      executable file's size drops by more than a half of the original size.

      Optimizations of the GUI version are also planned.

      (I realize that, given today's disk sizes, no-one is impressed by 
      saved 100 KBs. But I just happen to like small programs...)

    * New provider: CT24.cz

    * New provider: MSFotbal.CT24.cz

    * New provider: STV.LiveTV.sk

    * Check for new version (CLI: argument -v; GUI: About window) didn't
      use proxy server even if it was set in the INI file.



  v0.36

    * Relaxed a too-strict check for valid conversions between UTF8 and
      Wide: unknown characters used to result in an error message, now they
      are simply replaced with question marks and conversion continues.
      (Solves an inconsistent behavior of CeskaTelevize.cz, which sometimes
      worked and sometimes didn't, even with the same URL.)

    * Localization support.

      - Using existing translations: In its default state, the program will
        load the language version that matches your Windows' locale. You may
        force a particular language by changing the Language option in the
        INI file.

      - Creating your own translations: Please read the documenation for
        details.



  v0.35

    * New providers:
        - 5min.com
        - eHow.com
        - ExtremeTube.com (note: porn)
        - Flickr.com
        - FreeVideo.ru
        - GrindTV.com
        - KeezMovies.com (note: porn)
        - Muzu.tv
        - RingTV.com
        - SevenLoad.com
        - Spike.com
        - Stagevu.com
        - StupidVideos.com
        - TodaysBigThing.com
        - University of Minnesota (ima.umn.edu)



  v0.34

    * Removed the forgotten console window in GUI version.

    * Updated support for MySpace. Note: Only movies hosted on MySpace servers
      can be downloaded. Movies hosted elsewhere (e.g. Hulu.com) can't.

    * Support for TV Noe (http://tvnoe.tbsystem.cz).

    * Support for FreeCaster.tv.

    * Support for Mpora.com.

    * Support for VitalMtb.com.

    * If an output file already exists and the user agreed to overwrite, YTD
      tries to delete the file first and only after that start writing to it.
      It's an attempt to solve a strange behavior of Windows 7, which won't
      let YTD write to a pre-existing file.



  v0.33

    * Stream.cz: support for HQ video.

    * Joj.sk: Implemented two more ways to detect video address. This should
      fix the three problems of some movies not downloading at all, other 
      movies being replaced by some other movies and some movies not being
      downloaded in HQ. Please make sure you check any downloads from Joj
      carefully, as Joj's backend is apparently rather shoddy and it is
      quite possible there are even more possible storage formats.

    * VideaCesky.cz: Subtitles are also downloaded.

    * Fixed missing .po files in the source of MSDL library. Those are only
      needed for clean build, of no interest for end-users.

    * Support for proxy servers. There are new settings ProxyHost, ProxyPort, 
      ProxyUser and ProxyPassword in the INI file. See documentation for
      details.



  v0.32

    * Slightly rearranged icons in the GUI version.

    * Support for MegaVideo.com and MegaPorn.com.

    * Support for Wimp.com.

    * Support for UStream.tv.

      Note for developers: The AMF support is incomplete as of yet - it does
      not handle AMF3 at all, for starters. The support will be expanded as
      (and when needed).



  v0.31

    * Invalid date format in Joj.sk handling caused downloading of a wrong
      movie.



  v0.30

    * Experimental support for Joj.sk. Due to the fact that URL geenrator
      makes a number of unwarranted assumptions, it is to be expected that
      some movies will not download. I will need to know their URLs to fix
      them.

    * Support for Metropol TV (tvpraha11.cz).

    * Support for VideaCesky.cz. The same method can be used for downloads
      from other secondary providers (who don't host their videos, but instead
      use someone else's servers).



  v0.29

    * More compatibility fixes for Free Pascal. GUI version won't work for
      quite a some time, perhaps forever.

    * Fixed a bug in RTMPDUMP (used by, e.g. TV Nova or Barrandov), which 
      only allowed one stream to download and failed with all successive
      streams.

      This bug also meant that if you tried to download two RTMP streams at
      the same time, they were both written to one file, rendering this file
      invalid. This behqavior is also fixed.

    * Introduced a concept of "ultimate providers", which allow finer control
      over simultaneously downloaded stream. For example, if a stream is
      currently being downloaded from Stream.cz, another request from iPrima.cz
      (which uses Stream.cz as a content provider) should wait.

    * The graphical version ignored the "PreferRealMedia" setting for Ceska
      Televize.cz.



  v0.28

    * Support for more media providers:
       - Facebook.com
       - Kukaj.sk
       - LibimSeTi.cz
       - MojeVideo.cz
       - Myubo.sk
       - Videoalbumy.azet.sk
       - Wrzuta.pl

    * Movies from Nova.cz now download in high quality (.mp4).

    * RTMPDUMP_DLL.DLL was built with library PolarSSL rather than OpenSSL,
      which removes the dependency on CRYPTOEAY32-0.9.8.DLL and
      SSLEAY32-0.9.8.DLL. It means that RTMPDUMP_DLL grew by some 180 KB,
      though.

    * Program can now be built with FreePascal (http://www.freepascal.org),
      tested with version 2.4.0. Only command-line version is supported for
      now, though - GUI version (using project Lazarus) can be built, but
      won't run in GUI mode.



  v0.27

    * Support for more media providers:
       - Bing.com
       - Bofunk.com
       - Break.com.
       - CekniTo.cz (.sk)
       - Clipfish.de
       - CollegeHumor.com
       - CrunchyRoll.com
       - DailyHaha.com
       - DailyMotion.com
       - EbaumsWorld.com
       - ESPN.go.com
       - FileCabi.net
       - Free.Zoznam.sk
       - FreeRide.cz
       - GodTube.com
       - Guba.com
       - LiveLeak.com
       - LiveVideo.com
       - MetaCafe.com
       - MySpace.com Video (http://video.myspace.com)
       - PornHost.com (note: porn)
       - PornHub.com (note: porn)
       - PornoTube.com (note: porn)
       - Raajje.tv
       - RedTube.com (note: porn)
       - Rude.com (note: porn)
       - RuTube.ru
       - Shufuni.com (note: porn)
       - SpankingTube.com (note: porn)
       - Stickam.com
       - StreetFire.com
       - Tangle.com
       - TeacherTube.com
       - Tontuyau.com
       - Tube8.com (note: porn)
       - VideoClipsDump.com
       - Videu.de
       - Vimeo.com
       - XHamster.com (note: porn)
       - XNXX.com (note: porn)
       - XTube.com (note: porn)
       - XVideoHost.com (note: porn)
       - XVideos.com (note: porn)
       - YouPorn.com (note: porn)
       - Yuvutu.com (note: porn)
       - ZkoukniTo.cz (note: includes an adult section)

    * Added english documentation.

    * Cleaned-up licensing terms: The program is released under the
      GNU GPL3 license.

    * More source code cleanup.

    * RTMPDUMP updated to version 2.2d.

    * The RTMPDUMP_DLL.DLL library has been modified for easier maintenance.
      It now allows the full use of all features of RTMPDUMP, too.

    * The MSDL_DLL.DLL library has been modified for easier maintenance.
      It now allows the full use of all features of MSDL, too.

    * Support for an INI file with default values. See documentation for
      details.

    * Czech Television is now being downloaded in the highest quality. You can
      now choose between Windows Media (default) and Real Media streams (in
      the INI file).

    * Fixed download of Czech Television's program PORT so that the program is
      downloaded rather than advertisment.

    * Command-line argument -l shows a list of available providers.

    * Command-line argument -v tests for availability of a newer version.

    * GUI version has a new button 'About' (F1), which displays some basic 
      information about the program and checks for availability of a newer
      version. It shows a list of available providers (what you get if you
      use the -l argument on command-line), too.

    * Movies from YouTube have their filenames properly converted to ANSI
      encoding.



  v0.26

    * Support for YouTube channels (pages containing content of a particular
      user, e.g. http://www.youtube.com/titanicpiano14). They are handled in
      much the same way as playlists.



  v0.25

    * Support for Snotr.com.



  v0.24

    * Some YouTube videos couldn't be downloaded with the age-verification-
      bypass method of the last version, but they did work with the older
      download method of version 0.22. The code was modified to first try
      the age-verification-bypass method, and if unsuccessful, fall back
      to the old method.

      Example: http://www.youtube.com/watch?v=REpXf0cmJ64



  v0.23

    * Re-worked playlist support for less cluttered output in command-line
      version. This also allows faster and easier support for more playlist
      formats.

    * Support for "adult" videos at YouTube.

    * Parameter -e for logging failed downloads to a file.

    * Parameter -s for reading links from HTML source. Both local files and
      remote URLs are supported. Example:

      ytd.exe -s "http://www.somewebsite.com/movies.html"
      ytd.exe -s "c:\temp\movies.html"

    * Functions for reading URL list from listfile (like -i in CLI version)
      and reading URL list from HTML page or HTML file (like -s in CLI) were
      added to the graphical version.

    * GUI version can now save the list of unfinished downloads to a list
      file, which can be later read using the -i parameter.



  v0.22

    * GUI version now displays hints for each button.

    * Changed the default behavior when an existing file is encountered. The
      older versions used to overwrite such a file. This version asks the
      user what to do.

      You may use parameters -n (never overwrite - skip), -a (automatically
      overwrite - like the older versions), -r (rename automatically) and
      -k (ask) to define the behavior in advance.

      GUI version always asks, except when "Auto-overwrite" is checked - in
      that case existing files are automatically overwritten like in the older
      versions.

    * GUI version minimizes to system tray.

    * YouTube playlists (e.g. http://www.youtube.com/view_play_list?p=90D6E7C4DE68E49E)
      are supported. All videos on a playlist are scheduled for download.



  v0.21

    * The changes in version 0.19 apparently rendered HTTP-based providers,
      such as YouTube, inoperative. Fixed.



  v0.20

    * Czech TV: Support for program PORT.



  v0.19

    * Memory leaks due some un-freed regular expressions fixed.

    * YouTube: Video "http://www.youtube.com/watch?v=7INIRLe7x0Y" was saved
      with ".mp4" extension, although it really is a ".flv". It is possible
      you will encounter more such cases, because I don't have a full list
      of supported formats and their respective extensions. Just let me know
      the URL of a video with incorrect extension and I will fix it.

    * Support for http://www.tvcom.cz.

    * Support for http://www.markiza.sk. If a movie consists of several
      files, all will be downloaded.

    * Support for http://www.rozhlas.cz. If a movie consists of several
      files, all will be downloaded.



  v0.18

    * Support for the new YouTube design.



  v0.17

    * Support for MMS, MMSH, RTSP protocols and their tunnelling variants.
      You will need MSDL_DLL.DLL library, built as a slight modification of
      MSDL tool (http://msdl.sf.net).

    * Support for Czech TV (iVysilani).

    * RTMPDUMP updated to its current version.



  v0.16

    * Shortened output lines in command-line version, to work better with
      100+ MB files in default console size.

    * Support for TV Nova (nova.cz).



  v0.15:
  
    * Restructured source code to better facilitate new media sources.

    * Support for streams based on RTMP protocol. It is done through
      RTMPDUMP_DLL.DLL library, which is based on RTMPDUMP project
      (http://rtmpdump.mplayerhq.hu). The library requires OpenSSL 
      in version 0.9.8, specifically the libraries SSLEAY32-0.9.8.DLL
      and CRYPTOEAY32-0.9.8.DLL.

    * Support for Barrandov.tv.



  v0.14:

    * The changes for Stream.cz caused the other sources to stop working.

    * Updated the graphical interface (icons, buttons etc.).

    * Added support for building only CLI or only GUI version of the
      program: When calling BUILD.BAT, use the optional argument "CLI"
      (only command-line version) or "GUI" (only graphical version).
      Building just CLI version results in a much smaller EXE file,
      just GUI version gets rid of the console window. The default
      behavior is to use both CLI and GUI support in the same EXE file.

    * The Synapse library updated to release 39. Unfortunately, this does
      not fix the Stream.cz problem (see below).

    * Support for iPrima.cz (based on Stream.cz).



  v0.13:

    * Support for Stream.cz. Unfortunately, it contains an unknown error
      that occassionally occurs - see the main readme file.

    * Besides video name and file the CLI version now also displays the URL,
      which can be used - with some providers - to download movies using
      your favorite download manager.



  v0.12:

    * Fixed YouTube downloader to once again support movies without a HD
      version.
    
    * The graphical version was completely rebuilt. Now it shows an URL list,
      downloads multiple files at once etc.



  v0.11:

    * YouTube: Experimental support for higher-quality HD formats (720HQ,
      1080p). Please let me know if you encounter a video which doesn't
      work.



  v0.10:

    * The program was rewritten from scratch. Now it is possible to add
      support for more media providers than just YouTube.

    * All outputs were changed to an easier-to-read form.

    * Support for n-joy.cz.

    * Support for blip.tv.

    * Support for files with URL list (one URL per line) with parameter -i.

    * PCRE.DLL is now required.

    * Added version info and icon to the application.

    * Added a very simple graphical interface, which is displayed if the
      program is started without arguments.



  v0.06:

    * Support for URLs like http://www.youtube.com/v/(id)



  v0.05:

    * Cleaned up source codes and the build batch-file.

    * Support for URLs like http://www.youtube.com/watch/v/(id)
